【力扣】整数反转,判断是否溢出的数学解法

整数反转原题地址

方法一:数学

反转整数

如何反转一个整数呢?考虑整数操作的3个技巧:

  1. xmod10 可以取出 x 的最低位,如 x=123 , xmod10=3 。
  2. x/=10 可以去掉 x 的最低位,如 x=123 , x/=10 , x=12 。
  3. x=x*10+y 可以在 x 后面续上 y ,其中 y 是一位数,如 x=123 , y=4 , x=x*10+y , x=1234 。

假设要反转的整数为 x ,反转后的整数存储在变量 rev 中, rev 一开始初始化为 0 ,那么反复执行以下操作:

  1. digit=xmod10 ,取出 x 的最低位数。
  2. x/=10 ,去掉 x 的最低位数。
  3. rev=rev*10+digit ,在 rev 后面续上 digit 。

直到 x 为 0 为止,此时 rev 存储的数据符合题目要求。

判断溢出

问题在于,如何判断插入后的数据是否超出 INT_MIN,INT_MAX 的范围,导致溢出?

我们来探索不等式 成立的充分必要条件。

先看右半边,即 。

对于任意整数 i ,我们有 ,如对于 123 , 123/10=12 , 123mod10=3 , 123=12*10+3 。

不等式化为: ,带入 , , ,

移项化简得: ,记 ,

  1. 当 rev=m 时,如果还要推入数字,那么 digit≤2 ,因为 INT_MAX 的最高位为 2 ,此时不等式左边等于 0 ,右边为正数,不等式恒成立。
  2. 当 rev>m 时,不等式左边至少是 10 ,右边至多是 7 ,不等式恒不成立。
  3. 当 rev<m 时,不等式左边至多是 -10 ,右边至少是 7-9=-2 ,不等式恒成立。

所以原不等式右半边成立的充分必要条件是 ,即 。同理左半边成立的充分必要条件是 。

原不等式成立的充分必要条件是 。

cpp 复制代码
// 方法一:数学
class Solution
{
public:
    int reverse(int x)
    {
        int rev = 0;
        while (x)
        {
            if (rev < INT_MIN / 10 || rev > INT_MAX / 10)
            {
                return 0;
            }

            // rev 后面续上 x 的最低位
            rev = rev * 10 + x % 10;
            // 去掉 x 的最低位
            x /= 10;
        }

        return rev;
    }
};
相关推荐
灯澜忆梦2 小时前
【面向对象编程C++】| 基础语法
java·c++·算法
小蒋观天下2 小时前
专项方案:大场景港口AI安防、多干扰环境下的算法调优与落地实操
人工智能·深度学习·算法·安全·机器学习·计算机视觉·ai大模型
Evand J2 小时前
【电机滤波例程5】渐消因子自适应扩展卡尔曼滤波(EKF),MATLAB。PMSM负载突变下的状态估计。附下载链接
算法·matlab
H.莓飛2 小时前
【数据结构】二叉树_OJ题
linux·开发语言·数据结构·算法
好想像大佬一样能够ak所有3 小时前
Leetcode35.搜索插入位置
数据结构·算法·leetcode
aqiu1111113 小时前
【C++算法打怪专栏】LeetCode 165. 比较版本号(双指针与字符串流法)
c++·算法·leetcode
黄金龙PLUS3 小时前
如何基于置换算法来设计对称加密算法
算法·网络安全·密码学·哈希算法·同态加密
不会就选b3 小时前
算法日常・每日刷题--<动态规划>14
算法
赛博守夜人3 小时前
跨境业务与出海合规之九:海外买量投放与营销虚假流量(Ad Fraud):跨国机房群控与归因欺诈识别算法
算法·安全
镜子AI6 小时前
教培机构AI推荐系统实战:概念漂移检测算法——为什么“去年有效的推荐今年可能失效“
人工智能·算法